package com.gx.obe.step.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.components.core.enumeration.EvaluationStepEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 评审步骤对话框
 * @author chenxw
 */
public abstract class EvaluationStepSingleDialog extends EvaluationStepDialog {
	
	private final String ROLE_KEY = "roleType";
	
	private Composite roleTypeComposite;
	
	public EvaluationStepSingleDialog(Shell parentShell, TenderProjectEntity tenderProject, EvaluationStep evaluationStep) {
		super(parentShell, tenderProject, evaluationStep);
	}
	
	@Override
	protected void createFromArea(Composite fromComposite, Composite gridComposite) {
		Label label_1 = new Label(fromComposite, SWT.NONE);
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, false, 1, 1));
		label_1.setText(Messages.EvalExpert + "：");
		
		roleTypeComposite = new Composite(fromComposite, SWT.NONE);
		RowLayout rl_roleTypeComposite = new RowLayout(SWT.HORIZONTAL);
		rl_roleTypeComposite.marginBottom = 0;
		rl_roleTypeComposite.marginTop = 0;
		roleTypeComposite.setLayout(rl_roleTypeComposite);
		roleTypeComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Button expertLeaderBtn = new Button(roleTypeComposite, SWT.RADIO);
		expertLeaderBtn.setText(Messages.ExpertLeader);
		expertLeaderBtn.setData(ROLE_KEY, EvaluationStepEnum.EXPERT_LEADER);
		expertLeaderBtn.setSelection(true);
		
		Button projectManagerBtn = new Button(roleTypeComposite, SWT.RADIO);
		projectManagerBtn.setText(Messages.ProjectManager);
		projectManagerBtn.setData(ROLE_KEY, EvaluationStepEnum.OPERATOR);
	}
	
	@Override
	protected void setFromData(EvaluationStep evaluationStep) {
		WidgetUtils.setRadioChecked(roleTypeComposite, evaluationStep.getRoleType(), ROLE_KEY);
	}
	
	@Override
	protected void getFromData(EvaluationStep evaluationStep) {
		evaluationStep.setRoleType((String) WidgetUtils.getRadioVal(roleTypeComposite, ROLE_KEY));
	}
	
}
