package com.gx.obe.step.dialog;

import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.ExpertEvaluationStep;
import com.gx.obe.business.entity.ExpertEvaluationStepLogInfo;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.http.json.JsonUtil;
import com.gx.obe.message.Messages;
import com.gx.obe.step.service.StepService;
import com.gx.obe.step.utils.ExpertEvaluationStepLogInfoUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.service.expert.ExpertEvaluationResultService;
import com.gx.utils.ActionLogUtils;
import com.gx.utils.NowTimeUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import com.gx.obe.util.utils.StringUtils;

/**
 * @Description: 申请退回
 * @author guoyr
 */
public class ReEvaluationConfirmDialog extends EDialog {
	
	private Text historyApplyReasonText;
	private EButton applyReEvaluation_btn;
	private Label stepName;
	private Label textCount;
	private EvaluationStep evaluationStep;
	private ExpertEvaluationStep expertEvaluationStep;
	private Composite applyReason_composite;
	private Composite apply_composite;
	private SashForm sashForm;
	private TenderProjectService tenderProjectService;
	private EvaluationStepService evaluationStepService = new EvaluationStepService();
//	private ExpertEvaluationStepService expertEvaluationStepService ;
	private boolean confimrReback = false;
	private Text rebackReasonText;
	private boolean isApply = false;
	private ExpertEvaluationResultService expertEvaluationResultService;
//	private ExpertService expertService = ServiceFactory.getInstance("expertService", ExpertService.class);
	
	private StepService stepService = new StepService();
	private Label messageLabel;
	
	{
		LogUtils.logClass(ReEvaluationConfirmDialog.class);
	}
	
	public ReEvaluationConfirmDialog(Shell parentShell, EvaluationStep evaluationStep, ExpertEvaluationStep expertEvaluationStep) {
		super(parentShell);
		this.evaluationStep = evaluationStep;
		this.expertEvaluationStep = expertEvaluationStep;
		tenderProjectService = new TenderProjectService();
		setTitle(Messages.Button_reauthorizeEvaluation);
	}
	
	@Override
	protected Control createDialogArea(Composite parent) {
		
		Composite top = (Composite) super.createDialogArea(parent);
		GridLayout gl_top = new GridLayout(1, false);
		gl_top.verticalSpacing = 0;
		gl_top.horizontalSpacing = 0;
		gl_top.marginHeight = 0;
		gl_top.marginWidth = 0;
		top.setLayout(gl_top);
		
		Composite container = new Composite(top, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.marginHeight = 10;
		gl_container.marginWidth = 10;
		container.setLayout(gl_container);
		
		stepName = new Label(container, SWT.WRAP);
		stepName.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		stepName.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		stepName.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		stepName.setText(evaluationStep.getStepName());
		
		sashForm = new SashForm(top, SWT.NONE);
		sashForm.setBackground(ColorConstants.BORDER_LINE_COLOR);
		sashForm.setSashWidth(1);
		sashForm.setOrientation(SWT.VERTICAL);
		sashForm.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		applyReason_composite = new Composite(sashForm, SWT.NONE);
		applyReason_composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_applyReason_composite = new GridLayout(1, false);
		gl_applyReason_composite.marginHeight = 0;
		gl_applyReason_composite.verticalSpacing = 0;
		gl_applyReason_composite.marginWidth = 0;
		applyReason_composite.setLayout(gl_applyReason_composite);
		
		CLabel label_2 = new CLabel(applyReason_composite, SWT.NONE);
		label_2.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/tips.png"));
		label_2.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLUE));
		label_2.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		label_2.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		label_2.setText(Messages.Title_reBackReason);
		
		{
			ESepator label = new ESepator(applyReason_composite, SWT.SEPARATOR | SWT.HORIZONTAL);
			label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			label.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		}
		
		historyApplyReasonText = new Text(applyReason_composite, SWT.READ_ONLY | SWT.WRAP | SWT.V_SCROLL);
		historyApplyReasonText.setTopIndex(10);
		historyApplyReasonText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		historyApplyReasonText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		historyApplyReasonText.setText("");
		
		apply_composite = new Composite(sashForm, SWT.NONE);
		apply_composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_apply_composite = new GridLayout(1, false);
		gl_apply_composite.verticalSpacing = 0;
		gl_apply_composite.marginHeight = 0;
		gl_apply_composite.marginWidth = 0;
		apply_composite.setLayout(gl_apply_composite);
		
		CLabel message_label = new CLabel(apply_composite, SWT.WRAP);
		message_label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png"));
		message_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		message_label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		message_label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		message_label.setText(Messages.Title_reauthorizeEvaluationReason);
		
		{
			ESepator label = new ESepator(apply_composite, SWT.SEPARATOR | SWT.HORIZONTAL);
			label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			label.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		}
		
		rebackReasonText = new Text(apply_composite, SWT.WRAP | SWT.V_SCROLL);
		rebackReasonText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		rebackReasonText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		sashForm.setWeights(new int[] { 1, 1 });
		
		messageLabel = new Label(top, SWT.WRAP);
		messageLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		messageLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		messageLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		ESepator label = new ESepator(top, SWT.SEPARATOR | SWT.HORIZONTAL);
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(top, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/fill_bg.png"));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(3, false);
		composite_1.setLayout(gl_composite_1);
		
		textCount = new Label(composite_1, SWT.NONE);
		textCount.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		textCount.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		textCount.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		textCount.setText("");
		
		applyReEvaluation_btn = new EButton(composite_1, SWT.NONE);
		applyReEvaluation_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				saveAction();
			}
		});
		GridData gd_revokeBtn = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		applyReEvaluation_btn.setLayoutData(gd_revokeBtn);
		applyReEvaluation_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
		applyReEvaluation_btn.setText(Messages.Button_agree);
		
		EButton cancel_btn = new EButton(composite_1, SWT.NONE);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		cancel_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		GridData gd_cancleBtn = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		cancel_btn.setLayoutData(gd_cancleBtn);
		cancel_btn.setText(Messages.Button_close);
		init();
		return container;
	}
	
	/**
	 * @Description:初始化
	 * @author guoyr
	 */
	private void init() {
		expertEvaluationResultService = new ExpertEvaluationResultService();
//		stepName.setText("["+evaluationStep.getStepName()+"]重新授权评审");
		
		// 申请退回
		if (null != expertEvaluationStep && null != expertEvaluationStep.getApplyStatus() && expertEvaluationStep.getApplyStatus().equals(CommonEnum.YES)) {
			isApply = true;
			applyReEvaluation_btn.setText(Messages.Button_agree);
			String applyReason = StringUtils.isEmpty(expertEvaluationStep.getApplyReason()) ? "" : expertEvaluationStep.getApplyReason();
			historyApplyReasonText.setText(applyReason);
			historyApplyReasonText.setSelection(historyApplyReasonText.getText().length());
			sashForm.setMaximizedControl(applyReason_composite);
		} else {
			sashForm.setMaximizedControl(apply_composite);
			applyReEvaluation_btn.setText(Messages.Button_reauthorizeEvaluation);
		}
		
		if (tenderProjectService.isUploadEvalResult(evaluationStep.getTenderId())) {
			applyReEvaluation_btn.setEnabled(false);
			rebackReasonText.setEditable(false);
			messageLabel.setText("已完成评标并上传评标结果！");
			final String keyCharacter = PropertiesUtils.getProperty("keyCharacter", "g");
			if (null != keyCharacter && keyCharacter.length() > 0) {
				final Listener keyListener = new Listener() {
					public void handleEvent(Event e) {
						if ((e.stateMask == SWT.CTRL) && e.keyCode == keyCharacter.charAt(0)) {
							applyReEvaluation_btn.setEnabled(!applyReEvaluation_btn.getEnabled());
							rebackReasonText.setEditable(!rebackReasonText.getEditable());
						}
					}
				};
				apply_composite.getDisplay().addFilter(SWT.KeyDown, keyListener);;
				apply_composite.addDisposeListener(new DisposeListener() {
					public void widgetDisposed(DisposeEvent e) {
						apply_composite.getDisplay().removeFilter(SWT.KeyDown, keyListener);
					}
				});
			}
		}
		rebackReasonText.forceFocus();
		rebackReasonText.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent arg0) {
				textCount.setText(MessageFormat.format(Messages.Tips_inputWordsCountWidthMax, rebackReasonText.getText().trim().length(), 200));
			}
		});
		
	}
	
	/**
	 * @Description: 保存
	 * @author guoyr
	 */
	private void saveAction() {
		if (!applyReEvaluation_btn.getEnabled()) {
			return;
		}
		List<ExpertEvaluationStep> expertEvaluationStepList = new ArrayList<ExpertEvaluationStep>();
		if (null != expertEvaluationStep) {
//			List<ExpertEvaluationStepLogInfo> list = ExpertEvaluationStepLogInfoUtils.getExpertEvaluationStepLogInfo(expertEvaluationStep.getApplyReason());
//			if (list.size() >= 1) {
//				ExpertEvaluationStepLogInfo info = list.get(list.size() - 1);
//				info.setApproveDate(NowTimeUtils.getNowDate());
//				info.setApproveUserIdCard(Constants.USER.getIdCard() != null ? Constants.USER.getIdCard() : Constants.USER.getUserAccount());
//				info.setApproveUserAccount(Constants.USER.getUserAccount());
//				info.setApproveUserName(Constants.USER.getUserName());
//				expertEvaluationStep.setApplyReason(JsonUtil.jacksonObjectToStr(list));
//			}
			String applyReason = StringUtils.isEmpty(expertEvaluationStep.getApplyReason()) ? "" : expertEvaluationStep.getApplyReason();
			historyApplyReasonText.setText(applyReason);
			expertEvaluationStepList.add(expertEvaluationStep);
			if (isApply) {
				ActionLogUtils.addServerLog(evaluationStep.getTenderId(), "退回专家", expertEvaluationStep.getUserId() + "退回原因：" + historyApplyReasonText.getText());
			} else {
				ActionLogUtils.addServerLog(evaluationStep.getTenderId(), "同意退回", expertEvaluationStep.getUserId() + "退回原因：" + rebackReasonText.getText());
			}
			
		} else {
			ActionLogUtils.addServerLog(evaluationStep.getTenderId(), "退回所有" + evaluationStep.getStepName(), "退回原因：" + rebackReasonText.getText());
			expertEvaluationStepList = stepService.getEvaluationStepListByStepId(evaluationStep.getTenderId(), evaluationStep.getId());
		}
		if (!isApply) {
			if (rebackReasonText.getText().trim().length() == 0) {
				MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_pleaseEnter, Messages.Title_reauthorizeEvaluationReason));
				return;
			}
		}
		
		if (null != expertEvaluationStepList) {
			boolean clearExpertStep = false;
			//如果是废标
			if (com.gx.obe.components.core.enumeration.EvaluationStepEnum.WASTE_BID.equals(evaluationStep.getStepType())) {
				TenderProjectEntity tenderProjectEntity = new TenderProjectEntity();
				tenderProjectEntity.setId(evaluationStep.getTenderId());
				tenderProjectEntity.setEffectiveType(TenderProjectEnum.EFFECTIVE_YES);
				tenderProjectService.updateAssignProperty(tenderProjectEntity, new String[] { "id", "effectiveType", });
			} else if (com.gx.obe.components.core.enumeration.EvaluationStepEnum.PRE_EVALUATION.equals(evaluationStep.getStepType())) {
				clearExpertStep = true;
			}
			for (ExpertEvaluationStep everyExpertEvaluationStep : expertEvaluationStepList) {
				if (true) {
					expertEvaluationResultService.deleteExpertEvaluationResult(evaluationStep.getTenderId(), evaluationStep.getId(), everyExpertEvaluationStep.getUserId());
				}
				if (clearExpertStep) {
					stepService.deleteById(everyExpertEvaluationStep.getId());
					continue;
				}
//				if (null != everyExpertEvaluationStep.getApplyStatus() && everyExpertEvaluationStep.getApplyStatus().equals(CommonEnum.YES)) {
//					everyExpertEvaluationStep.setApplyStatus(null);
//					stepService.updateAssignProperty(everyExpertEvaluationStep, new String[] { "applyStatus", "applyReason" });
//				} else {
//					List<ExpertEvaluationStepLogInfo> expertEvaluationStepLogInfoList = ExpertEvaluationStepLogInfoUtils.getExpertEvaluationStepLogInfo(everyExpertEvaluationStep.getApplyReason());
//					Date date = NowTimeUtils.getNowDate();
//					ExpertEvaluationStepLogInfo info = new ExpertEvaluationStepLogInfo(rebackReasonText.getText(), Constants.USER.getUserName(), Constants.USER.getUserAccount(), Constants.USER.getIdCard(), "01", date, date, Constants.USER.getUserName(), Constants.USER.getIdCard(), Constants.USER.getUserAccount());
//					expertEvaluationStepLogInfoList.add(info);
//					everyExpertEvaluationStep.setApplyStatus(null);
//					everyExpertEvaluationStep.setApplyReason(JsonUtil.jsonObjectToStr(expertEvaluationStepLogInfoList));
//					stepService.updateAssignProperty(everyExpertEvaluationStep, new String[] { "applyStatus", "applyReason" });
//				}
				if(!isApply){
					SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
					StringBuilder reason = new StringBuilder();
					if(everyExpertEvaluationStep.getApplyReason() != null && everyExpertEvaluationStep.getApplyReason().length() > 0){
						reason.append(everyExpertEvaluationStep.getApplyReason());
						reason.append("\r\n");
					}
					reason.append(format.format(NowTimeUtils.getNowDate()));
					reason.append("\r\n      ");
					reason.append(rebackReasonText.getText().trim());
					everyExpertEvaluationStep.setApplyReason(reason.toString());
				}
				everyExpertEvaluationStep.setApplyStatus(null);
				stepService.updateAssignProperty(everyExpertEvaluationStep, new String[] { "applyStatus", "applyReason" });
			}
		}
//		//如果是废标
//		if(evaluationStep.getStepType().equals(EvaluationStepEnum.WASTE_BID)){
//			tenderProjectEntity = tenderProjectService.getById(evaluationStep.getTenderId(), TenderProjectEntity.class);
//			tenderProjectEntity.setEffectiveType(TenderProjectEnum.EFFECTIVE_YES);
//			tenderProjectService.updateAssignProperty(tenderProjectEntity, new String[] { "effectiveType", });
//			
//		}
		
		evaluationStepService.reBackEvaluationStep(evaluationStep, expertEvaluationStep);
		confimrReback = true;
		getShell().close();
		
	}
	
	public boolean isConfirmReback() {
		return confimrReback;
	}
	
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(650, 400);
	}
}
