package com.gx.obe.step.service;

import java.util.HashMap;
import java.util.Map;

import com.gx.obe.components.core.Constants;
import com.gx.obe.web.service.expert.ExpertEvaluationStepService;
import com.gx.obe.web.utils.NetworkRequest;
import com.gx.obe.web.utils.ResultStatus;

public class StepService extends ExpertEvaluationStepService {
	
	/**
	 * @Description: 提交评审步骤
	 * @author chenxw
	 * @param tenderId
	 * @param stepId
	 * @param userId
	 * @return
	 */
	public static boolean submitEvaluationStep(String tenderId, String stepId, String userId) {
		String strWebServerUrl = Constants.getServiceUrl(URL + "/submitEvaluationStep");
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
		param.put("stepId", stepId);
		param.put("userId", userId);
		try {
			String result = NetworkRequest.get(strWebServerUrl, param);
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
	
}
