package com.gx.obe.step.utils;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import com.gx.obe.business.entity.ExpertEvaluationStepLogInfo;
import com.gx.obe.http.json.JsonUtil;
import com.gx.obe.util.utils.StringUtil;

public class ExpertEvaluationStepLogInfoUtils {
	
	static SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	public static List<ExpertEvaluationStepLogInfo> getExpertEvaluationStepLogInfo(String applyReason) {
		if (applyReason == null) {
			return new ArrayList<ExpertEvaluationStepLogInfo>();
		}
		try {
			return JsonUtil.jsonToList(applyReason, ExpertEvaluationStepLogInfo.class);
		} catch (Exception e) {
			return new ArrayList<ExpertEvaluationStepLogInfo>();
		}
	}
	

	public static String getExpertEvaluationStepInfo(String applyReason){
		StringBuilder reason = new StringBuilder();
		if (StringUtil.empty(applyReason)) {
			return reason.toString();
		}
		try {
			List<ExpertEvaluationStepLogInfo> list = JsonUtil.jsonToList(applyReason, ExpertEvaluationStepLogInfo.class);
			for(ExpertEvaluationStepLogInfo info : list) {
				reason.append(format.format(info.getApplyDate()));
				reason.append("\r\n      ");
 				reason.append(info.getReason());
 				reason.append("\r\n");
			}
		} catch (Exception e) {
			return reason.toString();
		}
		
		return reason.toString();
	}
	
	
}
